using System;
using System.Text;
using System.Data;
using System.Text.RegularExpressions;
using BlogEngine.Core;
using BlogEngine.Core.Web.Controls;
using System.Web;

/// <summary>
/// Summary description for retweet
/// </summary>
/// 
[Extension("Inserts retweet, delicious and kick it buttons at the end of the content posts or pages", "", "")]
public class retweet
{
	
    private static string _Html;
    private static int bitly = 0; // 1 for bit.ly and 0 for tiny Url
    private static string bitlyUserName="bitlyUserName"; //If you are using bit.ly to shorten URL
    private static string bitlyApiKey = "R_";//If you are using bit.ly to shorten URL the API KEY
    private static string activateHistory = "1"; //0 or 1 If you are using bit.ly to shorten URL 
    private static string retweetimageUrl = "http://..../retweet.png"; // image you need to show as retweet button
    private static string deliciousimageUrl = "http://...../delicious.jpg"; // image you want to show as a delicious button
    private static string twitterUser = "krishnans"; // Your twitter user name will be used in the retweet

    /// <summary>
    /// Gets the HTML used to inserts the AdSense code.
    /// </summary>
    public static string Html
    {
        get
        {
            if (_Html == null)
            {
				StringBuilder sb = new StringBuilder();
                sb.Append("<table><tr><td style=\"width:52px;\" align=\"left\" valign=\"bottom\">"+
                    "<a href=\"[retweet]\" target=\"_blank\"><img src=\""+retweetimageUrl+"\" alt=\"Retweet\" style=\"border:none;\" /></a>" +
                    "</td><td  style=\"width:85px;\" align=\"center\" valign=\"bottom\">[kickit]</td><td  style=\"width:80px;\" align=\"center\" valign=\"bottom\">[delicious]</td></tr></table>");
                _Html = sb.ToString();
            }
            return _Html;
        }
    }

    public retweet()
	{
		Post.Serving += new EventHandler<ServingEventArgs>(Serving);
        Page.Serving += new EventHandler<ServingEventArgs>(Serving);
	}

	/// <summary>
	/// Serving AdSense code in post and page
	/// </summary>
	private static void Serving(object sender, ServingEventArgs e)
	{
		if ((e.Location == ServingLocation.SinglePost))
        {
            string _adScript = Html;
            Post post = (Post)sender;
            e.Body += _adScript;
            if (e.Location == ServingLocation.SinglePost)
            {
                String dotnetkicksToken = "[kickit]";
                String kickItButton = String.Format(@"<a target=""_blank"" href=""http://www.dotnetkicks.com/kick/?url={0}&title={1}""><img src=""http://www.dotnetkicks.com/Services/Images/KickItImageGenerator.ashx?url={0}"" border=""0"" alt=""kick it on DotNetKicks.com"" /></a>", post.AbsoluteLink,post.Title);
                e.Body = e.Body.Replace(dotnetkicksToken, kickItButton);
				String deliciousToken = "[delicious]";
				String deliciousButton = String.Format(@"<a target=""_blank"" href=""http://del.icio.us/post?url={0}&title={1}""><img src=""{2}"" border=""0"" alt=""Bookmark on delicious"" /></a>", post.AbsoluteLink,post.Title,deliciousimageUrl);
				e.Body = e.Body.Replace(deliciousToken, deliciousButton);
                e.Body = e.Body.Replace("[retweet]", getTweet(post.AbsoluteLink.ToString(), post.Title));
            }
            
        }
	}

    private static string getTinyUrl(string ur)
    {
        System.Globalization.CompareInfo cmpUrl = System.Globalization.CultureInfo.InvariantCulture.CompareInfo;
        if (!cmpUrl.IsPrefix(ur, "http://tinyurl.com"))
        {
            string address = "http://tinyurl.com/api-create.php?url=" + ur;
            System.Net.WebClient client = new System.Net.WebClient();
            return (client.DownloadString(address));
        }
        else
        {
            return (ur);
        }
    }

    private static string getbitly(string url)
    {
        System.Globalization.CompareInfo cmpUrl = System.Globalization.CultureInfo.InvariantCulture.CompareInfo;
        if (!cmpUrl.IsPrefix(url, "http://tinyurl.com"))
        {
            string address = "http://api.bit.ly/shorten?version=2.0.1&longUrl="+url+"&login="+bitlyUserName+"&apiKey="+bitlyApiKey+"&history="+activateHistory;
            System.Net.WebClient client = new System.Net.WebClient();
            string result = client.DownloadString(address);
            int indexOfBefore = result.IndexOf("shortUrl\": \"") + 12;
            int indexOfAfter = result.IndexOf("\"", indexOfBefore);
            return (result.Substring(indexOfBefore, indexOfAfter - indexOfBefore));
        }
        else
        {
            return (url);
        }
    }

    private static string getTweet(string url, string title)
    {
        string retweet = "http://twitter.com/home/?status=retweet+@" + twitterUser + " " + title.Replace(" ", "+") + "+-+";
        if (bitly == 1 && bitlyApiKey!="" && bitlyUserName !="")
        {
            retweet += getbitly(url);
        }
        else
        {
            retweet += getTinyUrl(url);
        }
        return (retweet);
    }


}
